package crawler;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import outputFormat.AmazonProduct;
import outputFormat.LVProduct;
import utility.ExcelManager;
import utility.SiteManager;

public class AmazonCrawler {
	
	//file to write the output on
	private static String outputFile = "excelfile/amazon.xls";
	//site url
	private static String siteurl = "http://www.amazon.com";
	//gender of the product 
	private static String gender;
	//	page to start crawl content
	
	private static String menPerfume = "http://www.amazon.com/s/qid=1219671933/ref=sr_nr_n_0?ie=UTF8&rs=11056591&keywords=perfume&bbn=11056761&rnid=11056591&rh=i%3Aaps%2Ck%3Aperfume%2Ci%3Abeauty%2Cn%3A3760911%2Cn%3A11056591%2Cn%3A11056761";
	//private static String menPerfume = "http://affiliate-program.amazon.com/gp/associates/network/build-links/individual/product-select.html/104-6743453-8184708?ie=UTF8&selectedSearchIndex=beauty&fieldKeywords=fragrance%20%20for%20women%20&page=2";
	
	private static String womenPerfume = "http://www.amazon.com/s/qid=1219755477/ref=sr_nr_n_1?ie=UTF8&rs=11056591&keywords=perfume&bbn=11056931&rnid=11056591&rh=i%3Aaps%2Ck%3Aperfume%2Ci%3Abeauty%2Cn%3A3760911%2Cn%3A11056591%2Cn%3A11056931";
	// crawled product counter
	private static int counter = 0;
	
	private static String priceUnit = "USD";
	//added by maoanz
	private static String quantity_unit = "Ounces";
	
//	image file save to fold
	private static String imgFold = "Amazon/";
	

	
	public static void main(String[] args){
		AmazonProduct ap = new AmazonProduct();
		ExcelManager.prepareFile(outputFile, ap);
		gender = "Men";
		crawlContent(menPerfume);
		gender = "Women";
		crawlContent(womenPerfume);
	}
	private static void crawlContent(String url) {
		//save the page to a String
		String doc = SiteManager.getDocumentFromURL(url, "Baiduspider+(+http://www.baidu.com/search/spider.htm)");
//		System.out.println("-------------------------------------------------------------------");
//		System.out.println("-------------------------------------------------------------------");
//		System.out.println("-------------------------------------------------------------------");
//		System.out.println(doc);
//		System.out.println("-------------------------------------------------------------------");
//		System.out.println("-------------------------------------------------------------------");
//		System.out.println("-------------------------------------------------------------------");
		//find product links
		Pattern prodLinkNameP = Pattern.compile("<a href=\"([^\"]*?)\"><span class=\"srTitle\">([^<]*?)</span></a>");
		Matcher prodLinkNameM = prodLinkNameP.matcher(doc);
		while(prodLinkNameM.find()){
			counter++;
			String link = prodLinkNameM.group(1);
			String name = prodLinkNameM.group(2);
			System.out.println("-------------------------------------------------------------------");
			System.out.println(counter+" product link: "+link);
			System.out.println("product name: "+name);
			crawlProduct(link, name);
			System.out.println("-------------------------------------------------------------------");
		}
		
		//find next page to crawl
		Pattern nextPageP = Pattern.compile("<a href=\"([^\"]*?)\"([^>]*?)>Next([^>]*?)>");
		Matcher nextPageM = nextPageP.matcher(doc);
		if(nextPageM.find()){
			String nextpage = siteurl+nextPageM.group(1);
			System.out.println("+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++");
			System.out.println("Next page to crawl products: "+nextpage);
			System.out.println("+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++");
			crawlContent(nextpage);
		}
	}
	private static void crawlProduct(String url, String name) {
		//save the page to a String
		String doc = SiteManager.getDocumentFromURL(url, "Baiduspider+(+http://www.baidu.com/search/spider.htm)");
//		System.out.println("-------------------------------------------------------------------");
//		System.out.println("-------------------------------------------------------------------");
//		System.out.println("-------------------------------------------------------------------");
//		System.out.println(doc);
//		System.out.println("-------------------------------------------------------------------");
//		System.out.println("-------------------------------------------------------------------");
//		System.out.println("-------------------------------------------------------------------");
		Pattern imageP = Pattern.compile("src=\"([^\"]*?)\" id=\"prodImage\" width=\"([^\"]*?)\" height=\"([^\"]*?)\"");
		Matcher imageM = imageP.matcher(doc);
		Pattern priceP = Pattern.compile("<b class=\"priceLarge\">([^<]*?)</b>");
		Matcher priceM = priceP.matcher(doc);
		
		Pattern descP = Pattern.compile("<b>Product Description</b><br />([^<]*?)<");
		Matcher descM = descP.matcher(doc); 
		
		Pattern brandP = Pattern.compile("<span >\nOther products by ([^>]*?)>([^<]*?)</a>");
		Matcher brandM = brandP.matcher(doc);
		
		Pattern quantityP = Pattern.compile("(*oz)");
		Matcher quantityM = quantityP.matcher(name);
		
		if (quantityM.find()){
			System.out.println(quantityM.group(1));
		}
				
		if(imageM.find()&&priceM.find()&&brandM.find() ){
			String image = imageM.group(1);
			String price = priceM.group(1).substring(1);
			
			System.out.println("maoanz: " + name );
			//added by maoanz
			String brand=""; 
			String quantity="";
			
			String desc = "";
//			String desc = descM.group(0);
		
			//System.out.println("Test");
			brand = brandM.group(2);			
			
			
			System.out.println("+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++");
			System.out.println("Product image: "+image);
			try {
				image = SiteManager.saveImage(image, imgFold, AmazonProduct.idCount);
			} catch (Exception e) {
				e.printStackTrace();
			}
			System.out.println("Product price: "+price);
			System.out.println("Brand: " + brand);
			if(descM.find()){
				desc = descM.group(0);
				desc = desc.substring(0, desc.length()-1).trim();
				System.out.println("Product description: "+desc);
			}
			System.out.println("+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++");
			System.out.println("Description: "+desc);
			AmazonProduct ap = new AmazonProduct(name, image, price, priceUnit, gender, desc, url, brand, quantity, quantity_unit);
			ExcelManager.writeToFile(ap);
		}
		
		
	}
}
