package utility;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;

import outputFormat.SheetWriter;

import jxl.Workbook;
import jxl.read.biff.BiffException;
import jxl.write.WritableCellFormat;
import jxl.write.WritableFont;
import jxl.write.WritableSheet;
import jxl.write.WritableWorkbook;
import jxl.write.WriteException;


public class ExcelManager {
	
	private static WritableWorkbook rwb;

	private static WritableSheet sheet;

	private static WritableFont wf;

	private static WritableCellFormat cf;
	
	private static String currentFileName;
	
	public static void prepareFile(String fileName, SheetWriter pro){
		currentFileName = fileName;
		File plf = new File(fileName);
		if (plf.exists()) {
			if (!plf.delete()) {
				System.err.println("Can't read file " + plf + " !");
				System.exit(-1);
			}
		}
		try {
			plf.createNewFile();
		} catch (IOException e) {
			e.printStackTrace();
		}
		OutputStream os = null;
		try {
			os = new FileOutputStream(plf);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			rwb = Workbook.createWorkbook(os);
		} catch (IOException e) {
			e.printStackTrace();
		}
		sheet = rwb.createSheet("products", 0);
		wf = new WritableFont(WritableFont.ARIAL, 10, WritableFont.BOLD);
		cf = new WritableCellFormat(wf);
		try {
			cf.setWrap(true);
		} catch (WriteException e) {
			e.printStackTrace();
		}
		pro.creatSheetLabels(sheet, cf);
		endWrite();
		try {
			os.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	private static void endWrite() {
		try {
			rwb.write();
		} catch (IOException e) {
			e.printStackTrace();
		}
		try {
			rwb.close();
		} catch (WriteException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static void writeToFile(SheetWriter pro) {
 		File plf = new File(currentFileName);
		if (!plf.exists()) {
			System.out.println("Error when loading: " + plf.getName());
			System.exit(-1);
		}
		OutputStream os = null;
		try {
			os = new FileOutputStream(plf);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
//		try {
//			rwb = Workbook.createWorkbook(os, Workbook.getWorkbook(plf));
//		} catch (IOException e) {
//			e.printStackTrace();
//		} catch (BiffException e) {
//			e.printStackTrace();
//		}
		try {
			rwb.setOutputFile(plf);
		} catch (IOException e) {
			e.printStackTrace();
		}

		sheet = rwb.getSheet(0);

		if (sheet != null) {
			pro.writeToSheet(sheet, cf);
		} else {
			System.err.println("Error can't find sheet products!");
			System.exit(-1);
		}
		endWrite();
	}

}
